package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: TransactionType
// UnionValue: CreateDataAccount

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("CreateDataAccount")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class CreateDataAccount implements TransactionBody {
	public final TransactionType type = TransactionType.CREATE_DATA_ACCOUNT;
	private Url url;
	private Url[] authorities;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public CreateDataAccount url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public CreateDataAccount url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public Url[] getAuthorities() {
	    return authorities;
	}
	public void setAuthorities(final Url[] value) {
	    this.authorities = value;
	}

	public CreateDataAccount authorities(final Url[] value) {
	    setAuthorities(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.authorities == null || this.authorities.length == 0)) {
            marshaller.writeUrl(3, this.authorities);
        }
        return marshaller.array();
    }
}
